routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Http\Controllers\Cabinet\CabinetController;
use App\Http\Controllers\Cabinet\DepositController;
use App\Http\Controllers\Cabinet\OperationController;
use App\Http\Controllers\Cabinet\SecurityController;
use App\Http\Controllers\Cabinet\TicketController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\NewsController;

app('zengine')->webRoutes();
if (setting('general.ssl_enabled')) {
    URL::forceScheme('https');
}

Route::get('/', [HomeController::class, 'index'])->name('home');
Route::get('faq', [HomeController::class, 'faq'])->name('faq');

Route::group(['prefix' => 'news', 'as' => 'news'], static function () {
    Route::get('/', [NewsController::class, 'index']);
    Route::get('{post}', [NewsController::class, 'show'])->name('.show');
    Route::get('{post}/watched', [NewsController::class, 'watched'])->name('.watched');
});

Route::group([
    'prefix'        => 'cabinet',
    'as'            => 'cabinet.',
    'middleware'    => 'auth'
], function () {
    Route::get('/', [CabinetController::class, 'index'])->name('index');
    Route::get('/referrals', [CabinetController::class, 'referrals'])->name('referrals');
    Route::get('/profile', [CabinetController::class, 'profile'])->name('profile');
    Route::post('/profile', [CabinetController::class, 'storeProfile'])->name('profile.store');
    Route::post('/wallets', [CabinetController::class, 'storeWallets'])->name('wallets.store');

    Route::get('/security', [SecurityController::class, 'index'])->name('security');
    Route::post('/security/password', [SecurityController::class, 'changePassword'])->name('security.password');
    Route::post('/security/2fa/enable', [SecurityController::class, 'enable2fa'])->name('security.2fa.enable');
    Route::post('/security/2fa/disable', [SecurityController::class, 'disable2fa'])->name('security.2fa.disable');
    Route::post('/security/pin/enable', [SecurityController::class, 'enablePin'])->name('security.pin.enable');
    Route::post('/security/pin/disable', [SecurityController::class, 'disablePin'])->name('security.pin.disable');
    Route::post('/security/pin/unlock', [SecurityController::class, 'unlock'])->name('security.pin.unlock');
    Route::get('/security/pin/lock', [SecurityController::class, 'lock'])->name('security.pin.lock');

    Route::get('/deposits', [DepositController::class, 'index'])->name('deposits');
    Route::get('/invest', [DepositController::class, 'create'])->name('deposits.create');
    Route::post('/invest', [DepositController::class, 'store'])->name('deposits.store');
    Route::get('/deposits/{deposit}/close', [DepositController::class, 'close'])->name('deposits.close');

    Route::get('/operations', [OperationController::class, 'index'])->name('operations');
    Route::post('/operations/{operation}/cancel', [OperationController::class, 'cancel'])->name('operations.cancel');

    Route::get('/refill/{status?}', [OperationController::class, 'refill'])->name('refill');
    Route::post('/refill', [OperationController::class, 'storeRefill'])->name('refill.store');

    Route::get('/withdraw/{status?}', [OperationController::class, 'withdraw'])->name('withdraw');
    Route::post('/withdraw', [OperationController::class, 'storeWithdraw'])->name('withdraw.store');

    Route::get('/transfer', [OperationController::class, 'transfer'])->name('transfer');
    Route::post('/transfer', [OperationController::class, 'storeTransfer'])->name('transfer.store');

    Route::resource('tickets', TicketController::class);
    Route::post('tickets/{ticket}/message', [TicketController::class, 'message'])->name('tickets.message');
    Route::post('tickets/{ticket}/status', [TicketController::class, 'status'])->name('tickets.status');
    Route::get('tickets/{ticket}/read', [TicketController::class, 'read'])->name('tickets.read');
});

app/Http/Controllers/Cabinet/CabinetController.php
<?php

namespace App\Http\Controllers\Cabinet;

use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Core\Models\Deposit;
use Modules\Core\Models\Operation;
use Modules\Core\Models\User;

class CabinetController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        /** @var User $user */
        $user = \Auth::user();
        $user->load('wallets.payment_system.currency');
        return view('cabinet.index', [
            'user'  => $user,
            'stats' => $this->getStats()
        ]);
    }

    protected function getStats() : array
    {
        $currencyService = app('currencies');
        /** @var \Modules\Core\Models\User $user */
        $user = \Auth::user();
        $stats = [];
        $stats['total_refills'] = $user->operations()->with('currency')->type(app('zengine')->modelClass('Operation')::TYPE_USER_REFILL)->status(app('zengine')->modelClass('Operation')::STATUS_SUCCESS)->get()
            ->reduce(static function ($total, Operation $operation) use ($currencyService) {
                return $total + $currencyService->convertToDefault($operation->amount, $operation->currency);
            }, 0);
        $stats['total_withdraws'] = $user->operations()->with('currency')->type(app('zengine')->modelClass('Operation')::TYPE_USER_WITHDRAW)->status(app('zengine')->modelClass('Operation')::STATUS_SUCCESS)->get()
            ->reduce(static function ($total, Operation $operation) use ($currencyService) {
                return $total + $currencyService->convertToDefault($operation->amount, $operation->currency);
            }, 0);
        $stats['deposits_opened_count'] = $user->deposits()->where('status', app('zengine')->modelClass('Deposit')::STATUS_OPEN)->count();
        $stats['deposits_closed_count'] = $user->deposits()->where('status', app('zengine')->modelClass('Deposit')::STATUS_CLOSED)->count();
        $stats['deposits_opened_sum'] = $user->deposits()->with('currency')->where('status', app('zengine')->modelClass('Deposit')::STATUS_OPEN)->get()
            ->reduce(static function ($total, Deposit $deposit) use ($currencyService) {
                return $total + $currencyService->convertToDefault($deposit->amount, $deposit->currency);
            }, 0);
        $stats['referrals_earned'] = $currencyService->convertToDefault($user->referrals_earned, $user->currency);
        $stats['referrals_count'] = $user->referrals_count;
        $stats['accruals_tomorrow'] = $this->accruals_tomorrow($user);
        return $stats;
    }

    protected function accruals_tomorrow(User $user)
    {
        $currencies = app('currencies');
        $deposits = $user->deposits()->with('plan')->where('left_accruals', '>', 0)->get();
        $diff_days = now()->diffInDays(now()->addDay(), 1);
        $diff_hours = now()->diffInHours(now()->addDay(), 1);
        $estimated = 0;
        foreach ($deposits as $deposit) {
            /** @var Deposit $deposit */
            if ($deposit->plan->type === app('zengine')->modelClass('Plan')::TYPE_DAILY) {
                $accrual = ($deposit->amount / 100) * $deposit->plan->percent;
                $estimated += $currencies->convertToDefault($accrual * min($deposit->left_accruals, $diff_days), $deposit->currency);
            } elseif ($deposit->plan->type === app('zengine')->modelClass('Plan')::TYPE_HOURLY) {
                $accrual = ($deposit->amount / 100) * $deposit->plan->percent;
                $estimated += $currencies->convertToDefault($accrual * min($deposit->left_accruals, $diff_hours), $deposit->currency);
            }
        }
        return $estimated;
    }

    public function referrals(Request $request)
    {
        $user = \Auth::user();
        $user->loadMissing(['inviter', 'referrals']);
        return view('cabinet.referrals', [
            'user'    => $user,
            'service' => app('users')
        ]);
    }

    public function profile(Request $request)
    {
        /** @var User $user */
        $user = \Auth::user();
        $user->loadMissing(['inviter', 'referrals']);
        $payment_systems = app('zengine')->model('PaymentSystem')->with([
            'wallets' => static function ($query) use ($user) {
                return $query->where('user_id', $user->id);
            }
        ])->enabled()->where('need_wallet', 1)->get();
        return view('cabinet.profile', [
            'user'              => $user,
            'payment_systems'   => $payment_systems,
            'service'           => app('users')
        ]);
    }

    /**
     * @param  Request  $request
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function storeProfile(Request $request)
    {
        $user = \Auth::user();
        $user->fill($request->only(['currency_id', 'name']));
        if ($user->isDirty('currency_id', 'name')) {
            $user->save();
            \Flash::success('Профиль обновлен');
        }
        return redirect(route('cabinet.profile'));
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function wallets()
    {
        $payment_systems = app('zengine')->model('PaymentSystem')->with([
            'wallets' => function ($query) {
                return $query->where('user_id', \Auth::id());
            }
        ])->enabled()->where('need_wallet', 1)->get();
        return view('cabinet.wallets', [
            'user'              => \Auth::user(),
            'payment_systems'   => $payment_systems,
        ]);
    }

    /**
     * @param  Request  $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function storeWallets(Request $request)
    {
        $user = \Auth::user();
        $wallets = $user->wallets()->pluck('wallet', 'payment_system_id');
        $data = $request->all();
        foreach ($data as $key => $value) {
            if (strpos($key, 'wallet_') !== 0 || !$value) {
                continue;
            }
            $payment_system = app('zengine')->model('PaymentSystem')->findOrFail((int) substr($key, 7));
            if (isset($wallets[$payment_system->id]) && $wallets[$payment_system->id] === $value) {
                continue;
            }
            $user->wallets()->updateOrCreate([
                'payment_system_id' => $payment_system->id
            ], [
                'wallet' => $value
            ]);
            \Flash::success("{$payment_system->name} saved");
        }
        return redirect()->back();
    }
}

app/Http/Controllers/Cabinet/DepositController.php
<?php

namespace App\Http\Controllers\Cabinet;

use App\Http\Requests\Cabinet\StoreDepositRequest;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Routing\Controller;
use Modules\Core\Models\Deposit;
use Modules\Core\Services\DepositService;

class DepositController extends Controller
{
    use AuthorizesRequests;

    /**
     * @var DepositService
     */
    private $depositService;

    public function __construct(DepositService $depositService)
    {
        $this->depositService = $depositService;
    }

    /**
     * Display a listing of the resource.
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        $deposits = app('zengine')->model('Deposit')->with(['plan', 'currency', 'wallet.payment_system'])->where('user_id', \Auth::id())
            ->latest()->paginate();
        return view('cabinet.deposits.index', compact('deposits'));
    }

    /**
     * Show the form for creating a new resource.
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        $plans = app('zengine')->model('Plan')->with('currency')->visible()->get();
        $currencies = app('zengine')->model('Currency')->all();
        $wallets = optional(\Auth::user())->wallets()->with('payment_system')->get();
        return view('cabinet.deposits.create', compact('plans', 'currencies', 'wallets'));
    }

    /**
     * Store a newly created resource in storage.
     * @param  StoreDepositRequest  $request
     * @return string[]
     * @throws \Exception
     */
    public function store(StoreDepositRequest $request)
    {
        \DB::beginTransaction();
        \Debugbar::info($request->all());
        try {
            $deposit = app('zengine')->model('Deposit')->create([
                'user_id'       => \Auth::id(),
                'plan_id'       => $request->get('plan_id'),
                'currency_id'   => $request->get('currency_id'),
                'wallet_id'     => $request->get('wallet_id'),
                'amount'        => $request->get('amount')
            ]);
            $this->depositService->create($deposit);
            \DB::commit();
            return [
                'status' => 'success'
            ];
        } catch (\Exception $exception) {
            \DB::rollBack();
            return [
                'status'  => 'error',
                'message' => $exception->getMessage(),
            ];
        }
    }

    /**
     * @param  Deposit  $deposit
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function close(Deposit $deposit)
    {
        $this->authorize('close', $deposit);
        $this->depositService->close($deposit);
        return redirect()->back();
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Response
     */
    public function show($id)
    {
        return view('cabinet.show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Response
     */
    public function edit($id)
    {
        return view('cabinet.edit');
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Cabinet/TicketController.php
<?php

namespace App\Http\Controllers\Cabinet;

use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Routing\Controller;
use Modules\Core\Models\Ticket;

class TicketController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Response
     */
    public function index()
    {
        return view('cabinet.tickets.index', [
            'tickets' => \Auth::user()->tickets()->latest()->paginate()
        ]);
    }

    /**
     * Show the form for creating a new resource.
     * @return Response
     */
    public function create()
    {
        return view('cabinet.tickets.create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Response
     */
    public function store(Request $request)
    {
        $ticket = \Auth::user()->tickets()->create([
            'subject' => $request->get('subject')
        ]);
        /** @var $ticket Ticket */
        $ticket->messages()->create([
            'user_id' => \Auth::id(),
            'message' => $request->get('message')
        ]);
        \Flash::success('Тикет отправлен');
        return redirect(route('cabinet.tickets.index'));
    }

    /**
     * Show the specified resource.
     * @param  Ticket  $ticket
     * @return Response
     */
    public function show(Ticket $ticket)
    {
        return view('cabinet.tickets.show', [
            'ticket' => $ticket
        ]);
    }

    /**
     * @param  Ticket  $ticket
     * @param  Request  $request
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function message(Ticket $ticket, Request $request)
    {
        $ticket->messages()->create([
            'user_id' => \Auth::id(),
            'message' => $request->get('message')
        ]);

        \Flash::success('Сообщение отправлено');
        return redirect(route('cabinet.tickets.show', $ticket));
    }

    /**
     * @param  Ticket  $ticket
     * @param  Request  $request
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function status(Ticket $ticket, Request $request)
    {
        $ticket->status = $request->get('status');
        $ticket->save();

        if ($request->get('status') === app('zengine')->modelClass('Ticket')::STATUS_OPEN) {
            \Flash::success('Тикет открыт');
        } elseif ($request->get('status') === app('zengine')->modelClass('Ticket')::STATUS_CLOSE) {
            \Flash::success('Тикет закрыт');
        }

        return redirect()->back();
    }

    /**
     * @param  Ticket  $ticket
     * @return array
     */
    public function read(Ticket $ticket)
    {
        $updated = $ticket->messages()->where('user_id', '!=', $ticket->user_id)->update([
            'read' => 1
        ]);
        return [
            'status' => $updated ? 'success' : 'not updated'
        ];
    }
}

resources/views/cabinet/index.blade.php
@extends('layouts.cabinet')

@section('body')
    <h1>{{ $user->login }} ({{ $user->balance }} {{ $user->currency->symbol }})</h1>
    <div class="row">
        @if(setting('balances_type') === 'divided')
        <div class="col-sm">
            @if(setting('balances_type') === 'divided')
                <h3>@lang('cabinet/home.wallets')</h3>
                <table class="table table-dark wallets-table">
                    <tr>
                        <th id="wallet">@lang('cabinet/home.wallet')</th>
                        <th id="balance">@lang('cabinet/home.balance')</th>
                    </tr>
                    @foreach($user->wallets as $wallet)
                        <tr>
                            <td>{{ $wallet->payment_system->name }}</td>
                            <td>{{ $wallet->balance }} {{ $wallet->payment_system->currency->symbol }}</td>
                        </tr>
                    @endforeach
                </table>
            @endif
        </div>
        @endif
        <div class="col-sm">
                <h3>@lang('cabinet/home.stats')</h3>
                <table class="table table-dark wallets-table">
                    <tr>
                        <td>Total Refills</td>
                        <td>{{ $stats['total_refills'] }} $</td>
                    </tr>
                    <tr>
                        <td>Total Withdraws</td>
                        <td>{{ $stats['total_withdraws'] }} $</td>
                    </tr>
                    <tr>
                        <td>Deposits opened count</td>
                        <td>{{ $stats['deposits_opened_count'] }}</td>
                    </tr>
                    <tr>
                        <td>Deposits closed sum</td>
                        <td>{{ $stats['deposits_closed_count'] }}</td>
                    </tr>
                    <tr>
                        <td>Deposits opened sum</td>
                        <td>{{ $stats['deposits_opened_sum'] }} $</td>
                    </tr>
                    <tr>
                        <td>Referrals earned</td>
                        <td>{{ $stats['referrals_earned'] }} $</td>
                    </tr>
                    <tr>
                        <td>Referrals count</td>
                        <td>{{ $stats['referrals_count'] }}</td>
                    </tr>
                    <tr>
                        <td>Accruals tomorrow</td>
                        <td>{{ $stats['accruals_tomorrow'] }} $</td>
                    </tr>
                </table>
        </div>
    </div>
@endsection

resources/views/cabinet/profile.blade.php
@extends('layouts.cabinet')

@section('body')
    @include('flash::message')
    @php /** @var $user \Modules\Core\Models\User */ @endphp
    <div class="clearfix"></div>
    <div class="row cabinet-profile">
        <div class="col-sm-12">
            <h1>@lang('cabinet/profile.title')</h1>
            {!! Form::model($user, ['route' => ['cabinet.profile.store'], 'method' => 'post']) !!}
            <div class="form-group">
                {!! Form::label('login', trans('cabinet/profile.form.login')) !!}
                {!! Form::text('login', null, ['class' => 'form-control ', 'readonly']) !!}
            </div>
            <div class="form-group">
                {!! Form::label('name', trans('cabinet/profile.form.name')) !!}
                {!! Form::text('name', null, ['class' => 'form-control '.( $errors->has('name') ? ' is-invalid' : '' )]) !!}
            </div>
            <div class="form-group">
                {!! Form::label('email', trans('cabinet/profile.form.email')) !!}
                {!! Form::text('email', null, ['class' => 'form-control', 'readonly']) !!}
            </div>
            <div class="form-group">
                {!! Form::label('currency_id', trans('cabinet/profile.form.currency')) !!}
                {!! Form::select('currency_id', app('zengine')->model('Currency')->pluck('code_iso', 'id'), null, ['class' => 'form-control' .( $errors->has('currency_id') ? ' is-invalid' : '' )]) !!}
            </div>
            <div class="form-group">
                {!! Form::label('invite_link', trans('cabinet/profile.form.invite_link')) !!}
                {!! Form::text('invite_link', null, ['class' => 'form-control', 'readonly']) !!}
            </div>
            @php
                $inviter = $user->inviter;
            @endphp
            @if($inviter)
                <div class="form-group">
                    {!! Form::label('inviter', 'Вас пригласил') !!}
                    {!! Form::text('inviter', "{$inviter->login}({$inviter->name})", ['class' => 'form-control', 'readonly']) !!}
                </div>
            @endif
            <button class="btn btn-primary" type="submit">@lang('cabinet/ui.save')</button>
            {!! Form::close() !!}
        </div>
    </div>
    <h2>@lang('cabinet/wallets.title')</h2>
    <form action="{{ route('cabinet.wallets.store') }}" method="POST">
        @csrf
        @foreach($payment_systems as $payment_system)
            @php /** @var \Modules\Core\Models\PaymentSystem $payment_system */ @endphp
            <div class="form-group">
                <label for="wallet_{{ $payment_system->id }}">{{ $payment_system->name }}</label>
                <input type="text" class="form-control" name="wallet_{{ $payment_system->id }}" id="wallet_{{ $payment_system->id }}"
                   @if($payment_system->wallets && $payment_system->wallets->count())
                       @cannot('can-modify', $payment_system->wallets[0])
                       readonly
                       @endcannot
                       value="{{ $payment_system->wallets[0]->wallet }}"
                    @endif
                >
            </div>
        @endforeach
        <button class="btn btn-primary" type="submit">@lang('cabinet/ui.save')</button>
        @can('locked')
            <button class="btn btn-secondary" type="button" @click="unlock_modal = true">@lang('cabinet/ui.unlock')</button>
        @endcan
    </form>
@endsection
@section('css')
    <style>
        .cabinet-profile .col-sm-12{
            margin-bottom: 1rem;
        }
    </style>
@endsection

resources/views/cabinet/referrals.blade.php
@extends('layouts.cabinet')

@section('body')
    @php /** @var $user \Modules\Core\Models\User */ @endphp
    <div class="clearfix"></div>
        @if($user->referrals)
            <div class="col-sm-12">
                <h1>@lang('cabinet/profile.referrals.title')</h1>
                <div class="form-group">
                    {!! Form::label('invite_link', trans('cabinet/profile.form.invite_link')) !!}
                    {!! Form::text('invite_link', $user->invite_link, ['class' => 'form-control', 'readonly']) !!}
                </div>
                @php($inviter = $user->inviter)
                @if($inviter)
                    <div class="form-group">
                        {!! Form::label('inviter', 'Вас пригласил') !!}
                        {!! Form::text('inviter', "{$inviter->login}({$inviter->name})", ['class' => 'form-control', 'readonly']) !!}
                    </div>
                @endif
                <table class="table">
                    <tr>
                        <th scope="col">#</th>
                        <th scope="col">@lang('cabinet/profile.referrals.login')</th>
                        <th scope="col">@lang('cabinet/profile.referrals.name')</th>
                        <th scope="col">@lang('cabinet/profile.referrals.earned')</th>
                        <th scope="col">@lang('cabinet/profile.referrals.level')</th>
                    </tr>
                    @php($referrals = $service->getFlattenReferrals($user))
                    @foreach($referrals as $referral)
                        <tr>
                            <td>{{ $referral->id }}</td>
                            <td>{{ $referral->login }}</td>
                            <td>{{ $referral->name }}</td>
                            <td>{{ $service->getReferralEarned($user, $referral) }} {{ $user->currency->symbol }}</td>
                            <td>{{ $referral->ref_level - $user->ref_level }}</td>
                        </tr>
                    @endforeach
                </table>
            </div>
        @endif
    </div>
@endsection
@section('css')
    <style>
        .cabinet-profile .col-sm-12{
            margin-bottom: 1rem;
        }
    </style>
@endsection

resources/views/cabinet/security.blade.php
@extends('layouts.cabinet')

@section('body')
    @include('flash::message')
    @php /** @var $user \Modules\Core\Models\User */ @endphp
    <div class="clearfix"></div>
    <div class="row cabinet-profile">
        <div class="col-sm-12">
            <h1>@lang('cabinet/security.change_password.title')</h1>
            {!! Form::model($user, ['route' => ['cabinet.security.password'], 'method' => 'post']) !!}
            <div class="form-group">
                {!! Form::label('old_password', trans('cabinet/security.change_password.old_password')) !!}
                {!! Form::password('old_password', ['class' => 'form-control '.( $errors->has('old_password') ? ' is-invalid' : '' )]) !!}
            </div>
            <div class="form-group">
                {!! Form::label('password', trans('cabinet/security.change_password.new_password')) !!}
                {!! Form::password('password', ['class' => 'form-control '.( $errors->has('password') ? ' is-invalid' : '' )]) !!}
            </div>
            <div class="form-group">
                {!! Form::label('password_confirmation', trans('cabinet/security.change_password.new_password_confirmation')) !!}
                {!! Form::password('password_confirmation', ['class' => 'form-control '.( $errors->has('password_confirmation') ? ' is-invalid' : '' )]) !!}
            </div>
            <button class="btn btn-primary " type="submit">@lang('cabinet/ui.save')</button>
            {!! Form::close() !!}
        </div>
        <div class="col-sm-12 mt-3">
            @include('cabinet/components.security_2fa')
        </div>
        <div class="col-sm-12 mt-3">
            @include('cabinet/components.security_pin')
        </div>
    </div>
@endsection
@section('css')
    <style>
        .cabinet-profile .col-sm-6{
            margin-bottom: 1rem;
        }
    </style>
@endsection